#!/usr/bin/perl

# Setzen der Variablen

$guestbookurl  = "http://www.gb-direkt.de/gastbuch/gastbuch.htm";		#URL des Gastbuchs
$guestbookreal = "/vserv/g/gb-dire1/htdocs/gastbuch/gastbuch.htm";	#absoluter Pfad
$guestlog      = "/vserv/g/gb-dire1/htdocs/gastbuch/gastlog.htm";		#absoluter Pfad
$cgiurl        = "http://www.gb-direkt.de/cgi-bin/gastbuch.cgi";		#URL des cgi-Skripts
$seperatimg    = "../_themes/sumipntg/sumhorsa.gif";				#relative URL des benutzerdefinierten Trennzeichens

# Setzen der Optionen:
$mail        = 1;		# 1 = Ja; 0 = Nein  - email an den Webmaster
$uselog      = 1;		# 1 = Ja; 0 = Nein  - Logbuch fuehren
$linkmail    = 1;		# 1 = Ja; 0 = Nein  - Web- und email-Adressen mit Hyperlinks
$separator   = 1;		# 1 = $seperatimg; 0 = <p> - Grafik zwischen den Eintraegen
$redirection = 1;		# 1 = Ja; 0 = Nein  - Automatisch zurck zum Gaestebuch
$entry_order = 1;       # 1 = Neueste Eintrge oben;
				# 0 = Neueste Eintrge unten.
$remote_mail = 1;		# 1 = Ja; 0 = Nein  - Dank-email an den Eintragenden
$allow_html  = 1;		# 1 = Ja; 0 = Nein  - HTML-Tags in der Eingabe erlauben
$line_breaks = 1;		# 1 = Ja; 0 = Nein  - Benutzerdefinierte Zeilenumbrueche

# Bei Option 1 fr $mail oder $remote_mail diese Variablen angeben 
$mailprog  = '/usr/sbin/sendmail';
$recipient = 'Bigorajski@T-Online.de';

# Ende Variablen setzen
##############################################################################

# Datumsroutine
$cent="20";
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$mon++;
if ($sec < 10)  { $sec = "0$sec";}
if ($min < 10)  { $min = "0$min";}
if ($hour < 10) { $hour = "0$hour";}
if ($mday < 10) { $mday = "0$mday";}
if ($mon < 10)  { $mon = "0$mon";}
$date = "$mday.$mon.$cent$year - $hour\:$min\:$sec"; # ergibt 99.99.1999 - 99:99:99
$shortdate = "$mday.$mon.$cent$year"; # ergibt 99.99.1999


# Eingaben abholen
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Name-Werte Paare auseinanderstellen
@pairs = split(/&/, $buffer);

foreach $pair (@pairs)
{
	($name, $value) = split(/=/, $pair);

	# Aussortieren von plus Zeichen und Mime-Dekodierung
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ s/<!--(.|\n)*-->//g;

	if ($allow_html != 1)
	{
		$value =~ s/<([^>]|\n)*>//g;
	}

	$FORM{$name} = $value;
}

# die Seiten fr leere Eingabefelder erstellen
&no_comments unless $FORM{'comments'};
&no_name unless $FORM{'realname'};

# Anfang Editierung der  Gaestebuch-Datei
open (FILE,"$guestbookreal") || die "Kann Datei $guestbookreal nicht ffnen: $!\n";

# Zeilenweises einlesen des Gstebuchs
@LINES = <FILE>;
close(FILE);

# Anzahl der Eintraege
$SIZE = @LINES;

# Datei fr die Ausgabe ffnen
open (GUEST,">$guestbookreal") || die "Kann Datei $guestbookreal nicht ffnen: $!\n";

for ($i=0;$i<=$SIZE;$i++)
{
	$_=$LINES[$i];
	if (/<!--begin-->/)
	{ 
		if ($entry_order eq '1')
		{
			print GUEST "<!--begin-->\n";
		}

		if ($FORM{'url'})
		{
			print GUEST "<font size=\"4\"><a href=\"$FORM{'url'}\">$FORM{'realname'}</a></font><font size=\"3\">";
		}
		else
		{
			print GUEST "<font size=\"4\">$FORM{'realname'}</font><font size=\"3\">";
		}

		print GUEST " - $date<br>\n";

		print GUEST "<img src=\"pictures\/$FORM{'picture'}\" width=\"32\" height=\"32\" align=\"left\">\n";

		if ( $FORM{'username'} )
		{
			if ($linkmail eq '1')
			{
				print GUEST "<b>&nbsp;email: </b><i>\&lt;<a href=\"mailto:$FORM{'username'}\">";
				print GUEST "$FORM{'username'}</a>\&gt;</i>";
			}
			else
			{
				print GUEST "<b>&nbsp;email: </b><i>&lt;$FORM{'username'}&gt;</i>";
			}
		}

		print GUEST "<br><b>&nbsp;aus:&nbsp;</b><i>\n";

		if ( $FORM{'city'} )
		{
			print GUEST "$FORM{'city'},";
		}
     
		if ( $FORM{'state'} )
		{
			print GUEST " $FORM{'state'}";
		}

		if ( $FORM{'country'} )
		{
			print GUEST " $FORM{'country'}";
		}

		print GUEST "</i><br>\n";

		print GUEST "<b>Meine Bewertung der Site&nbsp;&nbsp; - </b><i>$FORM{'siteval'}</i><br>\n";

		print GUEST "<b>Ich habe hergefunden durch - </b><i>$FORM{'foundby'}</i>\n";
		if ( $FORM{'idest'} )
		{
			print GUEST ": <i>$FORM{'idest'}</i>,";
		}
		print GUEST "<br>\n";


		if ($line_breaks == 1)
		{
			$FORM{'comments'} =~ s/\cM\n/<br>\n/g;
		}

		print GUEST "<b>Mein Kommentar - </b><i>$FORM{'comments'}</i><br></font>\n";

		if ($entry_order eq '0')
		{
			print GUEST "<!--begin-->\n";
		}

		if ($separator eq '1')
		{
			print GUEST "<p align=\"center\"><img src=\"$seperatimg\"></p>\n\n";
		}
		else
		{
			print GUEST "<p>&nbsp;<br></p>\n\n";
		}

	}
	else
	{
		print GUEST $_;
	}
}

close (GUEST);

# Den Eintrag ins Logbuch

if ($uselog eq '1')
{
	&log('entry');
}


#########
# Optionen

# Mail Option
if ($mail eq '1')
{
	open (MAIL, "|$mailprog $recipient") || die "Kann Mailprogramm $mailprog nicht ffnen: $!\n";

	print MAIL "Reply-to: $FORM{'username'} ($FORM{'realname'})\n";
	print MAIL "From: $FORM{'username'} ($FORM{'realname'})\n";
	print MAIL "Subject: Eintrag ins Gstebuch\n\n";
	print MAIL "Es gibt einen neuen Eintrag im Gstebuch:\n\n";
	print MAIL "------------------------------------------------------\n";
	print MAIL "$FORM{'comments'}\n";
	print MAIL "$FORM{'realname'}";

	if ( $FORM{'username'} )
	{
		print MAIL " <$FORM{'username'}>";
	}

	print MAIL "\n";

	if ( $FORM{'city'} )
	{
		print MAIL "$FORM{'city'},";
	}

	if ( $FORM{'state'} )
	{
		print MAIL " $FORM{'state'}";
	}

	if ( $FORM{'country'} )
	{
		print MAIL " $FORM{'country'}";
	}

	print MAIL " - $date\n";
	print MAIL "------------------------------------------------------\n";

	close (MAIL);
}

if ($remote_mail eq '1' && $FORM{'username'})
{
	open (MAIL, "|$mailprog -t") || die "Kann Mailrogramm $mailprog nicht ffnen $!\n";

	print MAIL "To: $FORM{'username'}\n";
	print MAIL "From: $recipient\n";
	print MAIL "Subject: Eintrag ins Gstebuch\n\n";
	print MAIL "Danke fr Ihren Eintrag in unser Gstebuch.\n\n";
	print MAIL "------------------------------------------------------\n";
	print MAIL "$FORM{'comments'}\n";
	print MAIL "$FORM{'realname'}";

	if ( $FORM{'username'} )
	{
		print MAIL " <$FORM{'username'}>";
	}

	print MAIL "\n";

	if ( $FORM{'city'} )
	{
		print MAIL "$FORM{'city'},";
	}

	if ( $FORM{'state'} )
	{
		print MAIL " $FORM{'state'}";
	}

	if ( $FORM{'country'} )
	{
		print MAIL " $FORM{'country'}";
	}

	print MAIL " - $date\n";
	print MAIL "------------------------------------------------------\n";

	close (MAIL);
}

# Zurck zum Gstabuch nach Eintrag
if ($redirection eq '1')
{
	print "Location: $guestbookurl\n\n";
}
else
{ 
	&no_redirection;
}

#######################
# Subroutinen

sub no_comments
{
	print "Content-type: text/html\n\n";
	print qq~
<html>
<head>
<title>Kein Kommentar?</title>
</head>
<body>
<h2>Ihre Kommentarzeile ist leer</h2>
Ohne einen Kommentar findet keine Eintragung ins Gstebuch statt.<p>
Bitte tragen Sie Ihren Kommentar hier ein:<p>
<form method="POST" action="$cgiurl">
Name:<input type="text" name="realname" size="40" value="$FORM{'realname'}"><br>
E-Mail: <input type="text" name="username" value="$FORM{'username'}" size=40><br>
Stadt: <input type="text" name="city" value="$FORM{'city'}" size="40"><br>
Land: <input type="text" name="country" value="$FORM{'country'}" size="40"><p>
Kommentar:<br>
<textarea name="comments" COLS="60" ROWS="4"></textarea><p>
<input type="hidden" name="picture" value="$FORM{'picture'}">
<input type="submit" value="Abschicken"> * <input type="reset" value="Nochmal neu">
</form>
<hr>
Zurck zum<a href="$guestbookurl">Gstebuch</a>.
</body>
</html>
	~;

	# Fehler ins Logbuch
	if ($uselog eq '1')
	{
		&log('no_comments');
	}

	exit;
}

sub no_name
{
	print "Content-type: text/html\n\n";
	print qq~
<html>
<head>
<title>Kein Name?</title>
</head>
<body>
<h2>Sie haben Ihren Namen vergessen!?</h2>
Das Feld fr Ihren Namen war nicht ausgefllt.<p>
Ohne Ihren Namen gibt es keinen Eintrag im Gstebuch.<br>
Bitte tragen Sie Ihren Namen in folgendes Formular.<p>
<form method="POST" action="$cgiurl">
Name:<input type="text" name="realname" size="40"><br>
E-Mail: <input type="text" name="username" value="$FORM{'username'}" size=40><br>
Stadt: <input type="text" name="city" value="$FORM{'city'}" size="40"><br>
Land: <input type="text" name="country" value="$FORM{'country'}" size="40"><p>
Ihr Kommentar bleibt erhalten.<p>
<input type="hidden" name="comments" value="$FORM{'comments'}">
<input type="hidden" name="picture" value="$FORM{'picture'}">
<input type="submit" value="Absenden">" * <input type="reset" value="Noch einmal">
</form>
<hr>
Zurck zum <a href="$guestbookurl">Gstebuch</a>.
</body>
</html>
	~;

	# Fehler ins Logbuch
	if ($uselog eq '1')
	{
		&log('no_name');
	}

	exit;
}

# Den Eintrag oder Fehler ins Logbuch
sub log
{
	$log_type = $_[0];
	open (LOG, ">>$guestlog");
	if ($log_type eq 'entry')
	{
		print LOG "$ENV{'REMOTE_HOST'} - [$shortdate]<br>\n";
	}
	elsif ($log_type eq 'no_name')
	{
		print LOG "$ENV{'REMOTE_HOST'} - [$shortdate] - ERR: Kein Name<br>\n";
	}
	elsif ($log_type eq 'no_comments')
	{
		print LOG "$ENV{'REMOTE_HOST'} - [$shortdate] - ERR: Kein Kommentar<br>\n";
	}
	close (LOG);
}

# Option redirection (Seite nachschieben)
sub no_redirection
{
	# HTML-Datei schreiben
	print "Content-Type: text/html\n\n";

	print qq~
<html>
<head>
<title>Danke!</title>
</head>
<body>
<h2>Vielen Dank fr den Eintrag ins Gstebuch</h2>
Ihr Eintrag wurde dem Gstebuch hinzugefgt.
<hr>
Hier noch einmal das, was Sie eingetragen haben:<p>
	~;

	if ($FORM{'url'})
	{
		print "<font size=\"4\"><a href=\"$FORM{'url'}\">$FORM{'realname'}</a></font><font size=\"3\">";
	}
	else
	{
		print "<font size=\"4\">$FORM{'realname'}</font><font size=\"3\">";
	}

	print " - $date<br>\n";

	print "<img src=\"$FORM{'picture'}\" width=\"32\" height=\"32\" align=\"left\">\n";

	if ( $FORM{'username'} )
	{
		if ($linkmail eq '1')
		{
			print "<b>email: </b><i>\&lt;<a href=\"mailto:$FORM{'username'}\">";
			print "$FORM{'username'}</a>\&gt;</i>";
		}
		else
		{
			print "<b>email: </b><i>&lt;$FORM{'username'}&gt;</i>";
		}
	}

	print "<br><b>aus:&nbsp;</b><i>\n";

	if ( $FORM{'city'} )
	{
		print "$FORM{'city'},";
	}
     
	if ( $FORM{'state'} )
	{
		print " $FORM{'state'}";
	}

	if ( $FORM{'country'} )
	{
		print " $FORM{'country'}";
	}

	print "</i><br>\n";

	print "<b>&nbsp;Meine Bewertung der Site&nbsp;&nbsp; - </b><i>$FORM{'siteval'}</i><br>\n";

	print "<b>&nbsp;Ich habe hergefunden durch - </b><i>$FORM{'foundby'}</i>\n";

	if ( $FORM{'idest'} )
	{
		print ": <i>$FORM{'idest'}</i>,";
	}

	print "<br>\n";

	if ($line_breaks == 1)
	{
		$FORM{'comments'} =~ s/\cM\n/<br>\n/g;
	}

	print qq~
<b>Mein Kommentar - </b><i>$FORM{'comments'}</i><br></font>
<hr>
<a href="$guestbookurl">Zurck zum Gstebuch</a><p>
- Wenn Sie Ihren Eintrag sehen wollen mssen Sie eventuell die Seite erneut laden.
</body>
</html>
	~;

	exit;
}
